#include <rpc/rpc.h>
#include <powerrpc.h>
#define RPC_CLIENT
#include "quote.h"
#define PWRPC_MT_ON_CALL PWRPC_ONC_MT

/* Default timeout can be changed using clnt_control() */
static struct timeval PWRPC_TIMEOUT_DEF = { 25, 0 };

#if !defined(RPC_RETURN_ARG)
quoteRec *
get_quote_2(inarg_ptr, clnt)
	char **inarg_ptr;
	CLIENT *clnt;
#else
int get_quote_2(inarg_ptr,  result_ptr, clnt)
	char **inarg_ptr;
	quoteRec *result_ptr;
	CLIENT *clnt;
#endif
{

#ifndef RPC_RETURN_ARG

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static quoteRec res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, get_quote, (xdrproc_t)xdr_wrapstring, inarg_ptr, (xdrproc_t)xdr_quoteRec, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
#else

	bzero((char *)result_ptr, sizeof(*result_ptr));
	return clnt_call(clnt, get_quote, (xdrproc_t)xdr_wrapstring, inarg_ptr, (xdrproc_t)xdr_quoteRec, result_ptr, PWRPC_TIMEOUT);
#endif

}


#if !defined(RPC_RETURN_ARG)
int *
trade_2(inarg_ptr, clnt)
	stockOrder *inarg_ptr;
	CLIENT *clnt;
#else
int trade_2(inarg_ptr,  result_ptr, clnt)
	stockOrder *inarg_ptr;
	int *result_ptr;
	CLIENT *clnt;
#endif
{

#ifndef RPC_RETURN_ARG

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, trade, (xdrproc_t)xdr_stockOrder, inarg_ptr, (xdrproc_t)xdr_int, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
#else

	bzero((char *)result_ptr, sizeof(*result_ptr));
	return clnt_call(clnt, trade, (xdrproc_t)xdr_stockOrder, inarg_ptr, (xdrproc_t)xdr_int, result_ptr, PWRPC_TIMEOUT);
#endif

}


#if !defined(RPC_RETURN_ARG)
pRec *
ping_2(inarg_ptr, clnt)
	void *inarg_ptr;
	CLIENT *clnt;
#else
int ping_2(inarg_ptr,  result_ptr, clnt)
	void *inarg_ptr;
	pRec *result_ptr;
	CLIENT *clnt;
#endif
{

#ifndef RPC_RETURN_ARG

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static pRec res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, ping, (xdrproc_t)xdr_void, inarg_ptr, (xdrproc_t)xdr_pRec, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
#else

	bzero((char *)result_ptr, sizeof(*result_ptr));
	return clnt_call(clnt, ping, (xdrproc_t)xdr_void, inarg_ptr, (xdrproc_t)xdr_pRec, result_ptr, PWRPC_TIMEOUT);
#endif

}

