#include <rpc/rpc.h>
#include "quote.h"
#define PWRPC_MT_ON_CALL PWRPC_ONC_MT


bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_comp_profile(xdrs, objp)
	XDR *xdrs;
	comp_profile *objp;
#else
xdr_comp_profile(XDR* xdrs, comp_profile* objp)
#endif
{
	if (!xdr_double(xdrs, &objp->earning)) {
		return (FALSE);
	}
	if (!xdr_double(xdrs, &objp->pe)) {
		return (FALSE);
	}
	if (!xdr_double(xdrs, &objp->mkt_cap)) {
		return (FALSE);
	}
	if (!xdr_pointer(xdrs, (char **)&objp->next, sizeof(comp_profile), xdr_comp_profile)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_quoteRec(xdrs, objp)
	XDR *xdrs;
	quoteRec *objp;
#else
xdr_quoteRec(XDR* xdrs, quoteRec* objp)
#endif
{
	if (!xdr_string(xdrs, &objp->company_name, MAXLEN)) {
		return (FALSE);
	}
	if (!xdr_double(xdrs, &objp->bid)) {
		return (FALSE);
	}
	if (!xdr_double(xdrs, &objp->ask)) {
		return (FALSE);
	}
	if (!xdr_u_long(xdrs, &objp->volume)) {
		return (FALSE);
	}
	if (!xdr_char(xdrs, &objp->trend)) {
		return (FALSE);
	}
	if (!xdr_pointer(xdrs, (char **)&objp->prof, sizeof(comp_profile), xdr_comp_profile)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_pRec(xdrs, objp)
	XDR *xdrs;
	pRec *objp;
#else
xdr_pRec(XDR* xdrs, pRec* objp)
#endif
{
	if (!xdr_pointer(xdrs, (char **)objp, sizeof(quoteRec), xdr_quoteRec)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_stockOrder(xdrs, objp)
	XDR *xdrs;
	stockOrder *objp;
#else
xdr_stockOrder(XDR* xdrs, stockOrder* objp)
#endif
{
	if (!xdr_vector(xdrs, (char *)objp->tick, 8, sizeof(char), xdr_char)) {
		return (FALSE);
	}
	if (!xdr_char(xdrs, &objp->trade_type)) {
		return (FALSE);
	}
	if (!xdr_u_long(xdrs, &objp->quantity)) {
		return (FALSE);
	}
	return (TRUE);
}


