
#include <rpc/rpc.h>
#include "quote.h"


//!!must choose multi-threaded dll in code generation 

int main()
{
	XDR xdrs;
	comp_profile cp;
	quoteRec qrec;

	FILE *fp=fopen("test", "wb");

	cp.earning=10.0;
	cp.pe=30.1;
	cp.mkt_cap=10000.0;
	cp.next =0;

	qrec.company_name="YHOO";
	qrec.bid=100.0;
	qrec.ask=101.0;
	qrec.volume=2000000;
	qrec.trend='D';
	qrec.prof=&cp;

	xdrstdio_create(&xdrs, fp, XDR_ENCODE);
	xdr_quoteRec(&xdrs, &qrec);
	fclose(fp);

	memset(&qrec, 0, sizeof(qrec));

	fp=fopen("test", "rb");

	xdrstdio_create(&xdrs, fp, XDR_DECODE);
	xdr_quoteRec(&xdrs, &qrec);
	printf("quote=%s, bid=%f, ask=%f, volume=%d, trend=%c, earning=%f, pe=%f, mkt_cap=%f\n", 
		qrec.company_name, qrec.bid, qrec.ask, qrec.volume, qrec.trend, qrec.prof->earning, qrec.prof->pe, qrec.prof->mkt_cap);
	xdr_free((xdrproc_t)xdr_quoteRec, (char *)&qrec);

	fclose(fp);

	return 0;
}
	


