/* License: @%%Netbula RPC Time Limited Demo, Commercial Distribution Prohibited! */

#ifndef quote_h
#define quote_h

#ifdef __cplusplus
extern "C" {
#endif
#include <rpc/types.h>

/*redefine below to use different timeout*/
#ifndef PWRPC_TIMEOUT
#define PWRPC_TIMEOUT PWRPC_TIMEOUT_DEF
#endif

#ifndef _RPCAPI
#define _RPCAPI  /* wanna change this? */
#endif

#define PWRPC_MT_ON_CALL PWRPC_ONC_MT
#define MAXLEN 256

struct comp_profile {
	double earning;
	double pe;
	double mkt_cap;
	struct comp_profile *next;
};
typedef struct comp_profile comp_profile;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_comp_profile();
#else
bool_t xdr_comp_profile(XDR*, comp_profile*);
#endif


struct quoteRec {
	char *company_name;
	double bid;
	double ask;
	u_long volume;
	char trend;
	struct comp_profile *prof;
};
typedef struct quoteRec quoteRec;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_quoteRec();
#else
bool_t xdr_quoteRec(XDR*, quoteRec*);
#endif


typedef quoteRec *pRec;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_pRec();
#else
bool_t xdr_pRec(XDR*, pRec*);
#endif


struct stockOrder {
	char tick[8];
	char trade_type;
	u_long quantity;
};
typedef struct stockOrder stockOrder;

#if !(defined(__cplusplus) || defined(__STDC__))
bool_t xdr_stockOrder();
#else
bool_t xdr_stockOrder(XDR*, stockOrder*);
#endif


#define quote ((u_long)22222)
#define quote_v1 ((u_long)2)
#define get_quote ((u_long)1)

#if !(defined(RPC_RETURN_ARG) && defined(RPC_CLIENT))
_RPCAPI extern quoteRec*
#else
_RPCAPI extern int
#endif
#ifndef __cplusplus
get_quote_2();
#else
get_quote_2(...); /*generated client stub*/
#endif


#if !defined(RPC_CLIENT)
_RPCAPI extern quoteRec*
#if !(defined(__cplusplus) || defined(__STDC__))
get_quote_2_svc(); /*service routine to be implemented*/
#else
get_quote_2_svc(char **, struct svc_req *rqstp); /*Programmer implements this for server */
#endif
#endif
#define trade ((u_long)2)

#if !(defined(RPC_RETURN_ARG) && defined(RPC_CLIENT))
_RPCAPI extern int*
#else
_RPCAPI extern int
#endif
#ifndef __cplusplus
trade_2();
#else
trade_2(...); /*generated client stub*/
#endif


#if !defined(RPC_CLIENT)
_RPCAPI extern int*
#if !(defined(__cplusplus) || defined(__STDC__))
trade_2_svc(); /*service routine to be implemented*/
#else
trade_2_svc(stockOrder *, struct svc_req *rqstp); /*Programmer implements this for server */
#endif
#endif
#define ping ((u_long)3)

#if !(defined(RPC_RETURN_ARG) && defined(RPC_CLIENT))
_RPCAPI extern pRec*
#else
_RPCAPI extern int
#endif
#ifndef __cplusplus
ping_2();
#else
ping_2(...); /*generated client stub*/
#endif


#if !defined(RPC_CLIENT)
_RPCAPI extern pRec*
#if !(defined(__cplusplus) || defined(__STDC__))
ping_2_svc(); /*service routine to be implemented*/
#else
ping_2_svc(struct svc_req *rqstp); /*Programmer implements this for server */
#endif
#endif

#ifdef __cplusplus
};
#endif


#endif
