#include <rpc/rpc.h>
#include "rstat.h" 

/*
 * Copyright (c) 1985, 1990, 1991 by Sun Microsystems, Inc.  
 */ 
/* from rstat.x */

CLIENT *clnt=0; 

statsvar prev;
void rstatit(host)
        char *host; 
{
        int i; 
        statsvar  *rs; 
        char *
        rstatproc_stats_4_arg; 
        u_int  *result_2; 
        char * rstatproc_havedisk_4_arg;
		float tot=0; /* total elapsed time */
	static int got_one =0;


        rs = rstatproc_stats_4((void *)&rstatproc_stats_4_arg, clnt);
        if (rs == (statsvar *) NULL) {
                clnt_perror(clnt, "call failed"); 
				return;
        } 
        result_2 = rstatproc_havedisk_4((void *)&rstatproc_havedisk_4_arg, clnt);
        if (result_2 == (u_int *) NULL) {
                clnt_perror(clnt, "call failed"); 
				return;
        }
	if(got_one ==0) {
		got_one =1;
		prev =*rs;
		return;
	}
        printf("\n\n%s@%d:%s", host,rs->curtime.tv_sec,
                ctime(&rs->curtime.tv_sec)); 
       
        printf("pgpgin=%d\tpgpgout=%d\tpswpin=%d\tpswpout=%d\n",
                rs->v_pgpgin-prev.v_pgpgin, rs->v_pgpgout-prev.v_pgpgout, rs->v_pswpin-prev.v_pswpin, rs->v_pswpout-prev.v_pswpout); 
        printf("intr=%d\tswtch=%d\tavenrun=%3.1f %3.1f %3.1f\n",
                rs->v_intr-prev.v_intr, rs->v_swtch-prev.v_swtch, rs->avenrun[0]/256.0,
                rs->avenrun[1]/256.0, rs->avenrun[2]/256.0);
        printf("ipackets=%d\tierrors=%d\topackets=%d\toerrors=%d\tcollisions=%d\n",
                rs->if_ipackets-prev.if_ipackets, rs->if_ierrors-prev.if_ierrors, rs->if_opackets-prev.if_opackets,
                rs->if_oerrors-prev.if_oerrors, rs->if_collisions-prev.if_collisions); 
        /* CPU states are 0=USER 1=WAIT 2=KERNEL 3=IDLE - weird... */ 

		 tot= rs->cp_time.cp_time_val[0]-
                prev.cp_time.cp_time_val[0]+
                rs->cp_time.cp_time_val[2]-
                prev.cp_time.cp_time_val[2]+
                rs->cp_time.cp_time_val[1]-
                prev.cp_time.cp_time_val[1]+ 
                rs->cp_time.cp_time_val[3]-
                prev.cp_time.cp_time_val[3];

        printf("CPU: usr=%.2f%%\tsys=%.2f%%\twio=%.2f%%\tidle=%.2f\n",
                100*(rs->cp_time.cp_time_val[0]-
                prev.cp_time.cp_time_val[0])/tot, 
                100*(rs->cp_time.cp_time_val[2]-
                prev.cp_time.cp_time_val[2])/tot,
                100*(rs->cp_time.cp_time_val[1]-
                prev.cp_time.cp_time_val[1])/tot, 
                100*(rs->cp_time.cp_time_val[3]-
                prev.cp_time.cp_time_val[3])/tot
		);
        for(i=0; i < rs->dk_xfer.dk_xfer_len; i++) {
            printf("disk%d xfers=%d\n", i, rs->dk_xfer.dk_xfer_val[i]-prev.dk_xfer.dk_xfer_val[i]); 
        } 
        prev = *rs;



}

main(argc, argv)
        int argc; char *argv[]; 
{
        char *host;
        int intv=10;
        int iter=10;

        if (argc < 2) {
                printf("usage:  %s server interval iteration\n", argv[0]);
                exit(1); 
        } 
        host = argv[1]; 
        if(argc>2)
        	intv=atoi(argv[2]);
        if(argc>3)
        	iter=atoi(argv[3]);
        clnt = clnt_create(host, RSTATPROG, RSTATVERS_VAR, "udp");
        if (clnt == (CLIENT *) NULL) {
                clnt_pcreateerror(host); 
                exit(1); 
        } 
        for(;iter;iter--) {
        	rstatit(host); 
                Sleep(1000*intv);
        }
        clnt_destroy(clnt); 
}
