/* License: @%%Netbula RPC Time Limited Demo, Commercial Distribution Prohibited! */

#ifndef rstat_hpp
#define rstat_hpp

#include "rstat.h"
#include <rpc/rpcclient.hpp>

/*
 * Copyright (c) 1985, 1990, 1991 by Sun Microsystems, Inc.
 */
/* from rstat.x */

#pragma ident	"@(#)rstat.x	1.8	97/04/11 SMI"

/*
 * Scale factor for scaled integers used to count load averages.
 */
#ifndef	FSCALE
#define	FSHIFT	8	/* bits to right of fixed binary point */
#define	FSCALE	(1<<FSHIFT)
#endif	/* ndef FSCALE */
#define DST_NONE
#ifndef DST_NONE
#include <sys/time.h>		/* The time struct defined below is	*/
#endif				/* meant to match struct timeval.	*/







#if defined(__STDC__) || defined(__cplusplus)
enum clnt_stat rstat(char *, struct statstime *);
int havedisk(char *);
#else
enum clnt_stat rstat();
int havedisk();
#endif

class CRSTATPROG: public RPCClient {

public:

	CRSTATPROG(const char*host, const char*proto, unsigned long prog=RSTATPROG_program, unsigned long vers=RSTATVERS_VAR_version)
		:RPCClient(host, proto, prog, vers){
	}

	inline int rstatproc_stats_4(void *inarg_ptr, statsvar *result_ptr )
 	{
		memset((char *)result_ptr, 0, sizeof(*result_ptr));
		if(clnt==NULL) return -1;
		return this->call(RSTATPROC_STATS, (xdrproc_t)xdr_void, inarg_ptr, (xdrproc_t)xdr_statsvar, result_ptr, this->timeout);
	}


	inline int rstatproc_havedisk_4(void *inarg_ptr, u_int *result_ptr )
 	{
		memset((char *)result_ptr, 0, sizeof(*result_ptr));
		if(clnt==NULL) return -1;
		return this->call(RSTATPROC_HAVEDISK, (xdrproc_t)xdr_void, inarg_ptr, (xdrproc_t)xdr_u_int, result_ptr, this->timeout);
	}


	inline int rstatproc_stats_3(void *inarg_ptr, statstime *result_ptr )
 	{
		memset((char *)result_ptr, 0, sizeof(*result_ptr));
		if(clnt==NULL) return -1;
		return this->call(RSTATPROC_STATS, (xdrproc_t)xdr_void, inarg_ptr, (xdrproc_t)xdr_statstime, result_ptr, this->timeout);
	}


	inline int rstatproc_havedisk_3(void *inarg_ptr, u_int *result_ptr )
 	{
		memset((char *)result_ptr, 0, sizeof(*result_ptr));
		if(clnt==NULL) return -1;
		return this->call(RSTATPROC_HAVEDISK, (xdrproc_t)xdr_void, inarg_ptr, (xdrproc_t)xdr_u_int, result_ptr, this->timeout);
	}


};


#endif
