#include <rpc/rpc.h>
#include <powerrpc.h>
#define RPC_CLIENT
#include "types.h"

/* Default timeout can be changed using clnt_control() */
static struct timeval PWRPC_TIMEOUT_DEF = { 25, 0 };

#if !defined(RPC_RETURN_ARG)
types *
inc_1(types *inarg_ptr,  CLIENT *clnt)
#else
int inc_1(types *inarg_ptr, types *result_ptr,  CLIENT *clnt)
#endif
{

#ifndef RPC_RETURN_ARG

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static types res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, inc, (xdrproc_t)xdr_types, inarg_ptr, (xdrproc_t)xdr_types, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
#else

	bzero((char *)result_ptr, sizeof(*result_ptr));
	return clnt_call(clnt, inc, (xdrproc_t)xdr_types, inarg_ptr, (xdrproc_t)xdr_types, result_ptr, PWRPC_TIMEOUT);
#endif

}


#if !defined(RPC_RETURN_ARG)
types *
dec_1(types *inarg_ptr,  CLIENT *clnt)
#else
int dec_1(types *inarg_ptr, types *result_ptr,  CLIENT *clnt)
#endif
{

#ifndef RPC_RETURN_ARG

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static types res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, dec, (xdrproc_t)xdr_types, inarg_ptr, (xdrproc_t)xdr_types, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
#else

	bzero((char *)result_ptr, sizeof(*result_ptr));
	return clnt_call(clnt, dec, (xdrproc_t)xdr_types, inarg_ptr, (xdrproc_t)xdr_types, result_ptr, PWRPC_TIMEOUT);
#endif

}

