#include <rpc/rpc.h>
#include <rpc/pmap_cln.h>
#define _RPC_SERVER
#include "types.h"
#include <powerrpc.h>
static SVCXPRT *tcp_master =0;
static SVCXPRT *udp_master =0;

static void
type_test_1(rqstp, transp)
	struct svc_req *rqstp;
	SVCXPRT *transp;
{
	union {
		types inc_1_OVER;
		types dec_1_OVER;
	} RPC_over;
	union {
		types inc_1_BACK;
		types dec_1_BACK;
	} RPC_back;
	pwrpc_call_struct callInfo;
	callInfo.ptransport = transp;
	callInfo.pover = (caddr_t)&RPC_over;
	callInfo.pback = (caddr_t)&RPC_back;
	callInfo.reply_now = 0;
#ifndef PWRPC_MT_ON_CALL
#define PWRPC_MT_ON_CALL 5
#endif
	callInfo.mt_on_call = PWRPC_MT_ON_CALL;
	callInfo.free_after = 0;
	callInfo.proc = 0;
	callInfo.psvc_req = rqstp;

	switch (rqstp->rq_proc) {
	case NULLPROC:
		(void)svc_sendreply(transp, xdr_void, (char *)NULL);
		return;

	case inc:
		callInfo.xdr_over = (xdrproc_t) xdr_types;
		callInfo.over_size = sizeof(RPC_over);
		callInfo.xdr_back = (xdrproc_t)xdr_types;
		callInfo.back_size = sizeof(RPC_back);
		callInfo.local = (local_call_t) inc_1_svc;
		break;

	case dec:
		callInfo.xdr_over = (xdrproc_t) xdr_types;
		callInfo.over_size = sizeof(RPC_over);
		callInfo.xdr_back = (xdrproc_t)xdr_types;
		callInfo.back_size = sizeof(RPC_back);
		callInfo.local = (local_call_t) dec_1_svc;
		break;

	default:
		svcerr_noproc(transp);
		return;
	}
	pw_serv_call(&callInfo);

}



main()
{
	SVCXPRT *transp;
	int sock = RPC_ANYSOCK;
	int proto = 0;
	pw_serv_init();
	(void)pmap_unset(type_test, v_1);

	sock=RPC_ANYSOCK;

#ifndef RPC_MT_CONNECT
#define RPC_MT_CONNECT 0
#endif
	pw_set_mt_on_connect(RPC_MT_CONNECT);

/*Define v_1_udp_server_port to used fixed port for this service*/
#ifdef v_1_udp_server_port
	sock = pw_serv_fd(v_1_udp_server_port, "udp");
#endif

	transp = svcudp_create(sock);
	if (transp == NULL) {
		server_err("cannot create udp service.\n");
		server_exit(1);
	}
		server_msg("Created udp service.\n");
	udp_master = transp;

/*Define v_1_udp_no_pmap to skip portmapper registration*/

#ifndef v_1_udp_no_pmap
	proto = IPPROTO_UDP;
#endif

	if (!svc_register(transp, type_test, v_1, type_test_1, proto)) {
		server_err("unable to register (type_test, v_1, udp).\n");
		server_exit(1);
	}

	sock=RPC_ANYSOCK;

#ifndef RPC_MT_CONNECT
#define RPC_MT_CONNECT 0
#endif
	pw_set_mt_on_connect(RPC_MT_CONNECT);

/*Define v_1_tcp_server_port to used fixed port for this service*/
#ifdef v_1_tcp_server_port
	sock = pw_serv_fd(v_1_tcp_server_port, "tcp");
#endif

	transp = svctcp_create(sock, 0, 0);
	if (transp == NULL) {
		server_err("cannot create tcp service.\n");
		server_exit(1);
	}
		server_msg("Created tcp service.\n");
	tcp_master = transp;

/*Define v_1_tcp_no_pmap to skip portmapper registration*/

#ifndef v_1_tcp_no_pmap
	proto = IPPROTO_TCP;
#endif

	if (!svc_register(transp, type_test, v_1, type_test_1, proto)) {
		server_err("unable to register (type_test, v_1, tcp).\n");
		server_exit(1);
	}
	pw_serv_mainloop(tcp_master, udp_master, 0, 1);
	server_err("svc_run returned\n");
	exit(1);return 0;
}
