#include <rpc/rpc.h>
#include "types.h"


bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_quote(xdrs, objp)
	XDR *xdrs;
	quote *objp;
#else
xdr_quote(XDR* xdrs, quote* objp)
#endif
{
	if (!xdr_int(xdrs, &objp->v1)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->v2)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_NUM(xdrs, objp)
	XDR *xdrs;
	NUM *objp;
#else
xdr_NUM(XDR* xdrs, NUM* objp)
#endif
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_un(xdrs, objp)
	XDR *xdrs;
	un *objp;
#else
xdr_un(XDR* xdrs, un* objp)
#endif
{
	if (!xdr_int(xdrs, &objp->which)) {
		return (FALSE);
	}
	switch (objp->which) {
	case INT:
		if (!xdr_int(xdrs, &objp->un_u.iv)) {
			return (FALSE);
		}
		break;
	case TS:
		if (!xdr_quote(xdrs, &objp->un_u.q)) {
			return (FALSE);
		}
		break;
	default:
		return (FALSE);
	}
	return (TRUE);
}




bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_un2(xdrs, objp)
	XDR *xdrs;
	un2 *objp;
#else
xdr_un2(XDR* xdrs, un2* objp)
#endif
{
	if (!xdr_NUM(xdrs, &objp->which)) {
		return (FALSE);
	}
	switch (objp->which) {
	case ONE:
		if (!xdr_int(xdrs, &objp->un2_u.iv)) {
			return (FALSE);
		}
		break;
	case TWO:
		if (!xdr_quote(xdrs, &objp->un2_u.q)) {
			return (FALSE);
		}
		break;
	default:
		return (FALSE);
	}
	return (TRUE);
}




bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_type_st(xdrs, objp)
	XDR *xdrs;
	type_st *objp;
#else
xdr_type_st(XDR* xdrs, type_st* objp)
#endif
{
	if (!xdr_char(xdrs, &objp->c)) {
		return (FALSE);
	}
	if (!xdr_short(xdrs, &objp->s)) {
		return (FALSE);
	}
	if (!xdr_int(xdrs, &objp->i)) {
		return (FALSE);
	}
	if (!xdr_long(xdrs, &objp->l)) {
		return (FALSE);
	}
	if (!xdr_u_long(xdrs, &objp->h)) {
		return (FALSE);
	}
	if (!xdr_float(xdrs, &objp->f)) {
		return (FALSE);
	}
	if (!xdr_double(xdrs, &objp->d)) {
		return (FALSE);
	}
	if (!xdr_bytes(xdrs, (char **)&objp->o.o_val, (u_int *)&objp->o.o_len, ~0)) {
		return (FALSE);
	}
	if (!xdr_NUM(xdrs, &objp->num)) {
		return (FALSE);
	}
	if (!xdr_pointer(xdrs, (char **)&objp->pi, sizeof(int), xdr_int)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->i_var_arr.i_var_arr_val, (u_int *)&objp->i_var_arr.i_var_arr_len, 20, sizeof(int), xdr_int)) {
		return (FALSE);
	}
	if (!xdr_vector(xdrs, (char *)objp->i_arr, 10, sizeof(int), xdr_int)) {
		return (FALSE);
	}
	if (!xdr_pointer(xdrs, (char **)&objp->pst, sizeof(type_st), xdr_type_st)) {
		return (FALSE);
	}
	if (!xdr_array(xdrs, (char **)&objp->qarr.qarr_val, (u_int *)&objp->qarr.qarr_len, ~0, sizeof(quote), xdr_quote)) {
		return (FALSE);
	}
	if (!xdr_vector(xdrs, (char *)objp->qarr2, TS, sizeof(quote), xdr_quote)) {
		return (FALSE);
	}
	if (!xdr_un(xdrs, &objp->v3)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
#if !(defined(__cplusplus) || defined(__STDC__))
xdr_types(xdrs, objp)
	XDR *xdrs;
	types *objp;
#else
xdr_types(XDR* xdrs, types* objp)
#endif
{
	if (!xdr_type_st(xdrs, objp)) {
		return (FALSE);
	}
	return (TRUE);
}


