#include <rpc/rpc.h>
#include <powerrpc.h>
#include "quote.h"
#define PWRPC_MT_ON_CALL PWRPC_ONC_MT

/* Default timeout can be changed using clnt_control() */
static struct timeval PWRPC_TIMEOUT_DEF = { 25, 0 };

quoteRec *
get_quote_2(argp, clnt)
	char **argp;
	CLIENT *clnt;
{

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static quoteRec res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, get_quote, xdr_wrapstring, argp, xdr_quoteRec, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


int *
trade_2(argp, clnt)
	stockOrder *argp;
	CLIENT *clnt;
{

#ifdef PWRPC_MT
	_declspec(thread)
#endif
	static int res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, trade, xdr_stockOrder, argp, xdr_int, &res, PWRPC_TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}

